#
#  TECS Generator
#      Generator for TOPPERS Embedded Component System
#  
#   Copyright (C) 2008-2009 by TOPPERS Project
#--
#   嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
#   ܥեȥѤΤޤࡥʲƱˤѡʣ
#   ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
#   (1) ܥեȥ򥽡ɤηѤˤϡ嵭
#       ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
#       ˴ޤޤƤ뤳ȡ
#   (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
#       ѤǤǺۤˤϡۤȼɥȡ
#       ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
#       ̵ݾڵǺܤ뤳ȡ
#   (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
#       ѤǤʤǺۤˤϡΤ줫ξ
#       ȡ
#     (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
#         ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
#     (b) ۤη֤̤ˡˤäơTOPPERSץȤ
#         𤹤뤳ȡ
#   (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
#       ⡤嵭ԤTOPPERSץȤդ뤳ȡ
#       ޤܥեȥΥ桼ޤϥɥ桼Τʤ
#       ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
#       դ뤳ȡ
#  
#   ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
#   TOPPERSץȤϡܥեȥ˴ؤơλŪ
#   ФŬޤơʤݾڤԤʤޤܥեȥ
#   ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
#   Ǥʤ
#  
#   $Id: RPCPlugin.rb 84 2008-05-04 14:19:09Z okuma-top $
#++

# mikan through plugin: namespace θƤʤ
# Ѥ硢ʲΤ褦 toppers_jsp.cdl sChannel.cdl ꤹɬפ
# tecsgen toppers_jsp.cdl sChannel.cdl your_description.cdl

# ʲ»
#  ƤӸƤΥǥchar, short, int_t, long_t, intptr_t ΥƱ
#  ͭ桢̵ǥƱ

require_tecsgen_lib "GenOpaqueMarshaler.rb"

class OpaqueRPCPlugin < ThroughPlugin

  # ץ饰̾ Proc
  RPCPluginArgProc = {
    "taskPriority"    => Proc.new { |obj,rhs| obj.set_taskPriority rhs },
    "stack_size"      => Proc.new { |obj,rhs| obj.set_stack_size rhs },
    "clientChannelCelltype" => Proc.new { |obj,rhs| obj.set_clientChannelCelltype rhs },
    "serverChannelCelltype" => Proc.new { |obj,rhs| obj.set_serverChannelCelltype rhs },
    "taskCelltype"    => Proc.new { |obj,rhs| obj.set_taskCelltype rhs },
    "PPAllocatorSize" => Proc.new { |obj,rhs| obj.set_PPAllocatorSize rhs }
  }

  include GenOpaqueMarshaler

  #=== RPCPlugin  initialize
  #   ThroughPlugin (plugin.rb) 򻲾
  def initialize( cell_name, plugin_arg, next_cell_name, next_cell_port_name, signature_name, celltype )
    @task_priority = 11
    @stack_size  = 4096
    @serverChannelCelltype = "tSocketServer"
    @clientChannelCelltype = "tSocketClient"
    @taskCelltype = "tTask"
    @clientRegion = "rClient"
    @serverRegion = "rServer"
    @PPAllocatorSize = nil
    super

    if @signature.need_PPAllocator? then
      if @PPAllocatorSize == nil then
        Generator.error( "PPAllocatorSize must be speicified for oneway [in] array" )
      end
    end
  end

  def gen_plugin_decl_code( file )

    ct_name = "#{@ct_name}_#{@serverChannelCelltype}"

    # Υ륿סƱ˥ˤϴƤ뤫
    if @@generated_celltype[ ct_name ] == nil then
      @@generated_celltype[ ct_name ] = [ self ]
    else
      @@generated_celltype[ ct_name ] << self
      return
    end

    sig_name = "#{@ct_name}"
    f = CFile.open( "#{$gen}/#{sig_name}.cdl", "w" )
    # ƱƤٽ񤯲ǽ (AppFile Բ)

    f.print <<EOT

celltype #{@ct_name}_marshaler {
  entry #{@signature.get_name} eClientEntry;
  call sTDR cTDR;
};
celltype #{@ct_name}_unmarshaler {
  call #{@signature.get_name} cServerCall;
  call  sTDR      cTDR;
  entry sTaskBody  doService;
};
EOT
    f.close

    f = CFile.open( "#{$gen}/#{ct_name}.cdl", "w" )
    # ƱƤٽ񤯲ǽ (AppFile Բ)

    f.print <<EOT
import( "sChannel.cdl" );
import( "TDR.cdl" );
import( "#{sig_name}.cdl" );

/* RPC Client side composite celltype */
composite #{@ct_name}Client {
  /* marshaler entry port */
  entry #{@signature.get_name} eThroughEntry;
  /* TDR control entry port */
  entry sTDR eTDR;

  cell #{@clientChannelCelltype} #{@signature.get_name}_clientChannel{
  };
  cell tTDR #{@ct_name}_marshaler_tdr {
    cChannel = #{@signature.get_name}_clientChannel.eC0;
  };
  cell #{@ct_name}_marshaler #{@signature.get_name}_marshaler{
    cTDR = #{@ct_name}_marshaler_tdr.eTDR;
  };

  composite.eThroughEntry => #{@signature.get_name}_marshaler.eClientEntry;
  composite.eTDR => #{@ct_name}_marshaler_tdr.eTDR;
};

/* RPC Server side composite celltype */
[active]
composite #{@ct_name}Server {
  /* Interface */
  attr {
    PRI    taskPriority = 11;
    SIZE   stack_size;
  };
  call #{@signature.get_name} #{@call_port_name};

  /* Implementation */
  cell #{@serverChannelCelltype} #{@signature.get_name}_serverChannel{
  };
  cell tTDR #{@ct_name}_unmarshaler_tdr {
    cChannel = #{@signature.get_name}_serverChannel.eC1;
  };
  cell #{@ct_name}_unmarshaler #{@signature.get_name}_unmarshaler{
    cTDR = #{@ct_name}_unmarshaler_tdr.eTDR;
    cServerCall => composite.#{@call_port_name};
  };
  cell #{@task_celltype} task {
    cBody = #{@signature.get_name}_unmarshaler.doService;
    priority      = taskPriority;       /* mikan : ץ饤ƥ */
    taskAttribute = C_EXP( "TA_ACT" );  /* mikan : marshaler Ϻǽ餫鵯ư */
    stackSize     = composite.stack_size;
  };
};
EOT

    f.close
  end

  #===  through cell ɤ
  #
  #
  def gen_through_cell_code( file )

    gen_plugin_decl_code( file )

    # õ
    path =["::",@next_cell_name]
    cell = Namespace.find( path )

    file.print <<EOT
import( "#{$gen}/#{@ct_name}_#{@serverChannelCelltype}.cdl" );
EOT

    # λ꤬뤫
    if cell.get_allocator_list.length > 0

      file.print "[allocator("

      delim = ""
      cell.get_allocator_list.each do |eport, subsc, func, buf, alloc|

        file.print delim
        delim = ",\n"        # ǽԤˤϽФʤ

        if subsc then        # ź
          subsc_str = '[#{subsc}]'
        else
          subsc_str = ""
        end

        eport = "eThroughEntry" #RPCμ̾ѹ
        file.print  "#{eport}#{subsc_str}.#{func}.#{buf} = #{alloc}"
      end

      file.puts ")]"
    end

    file.print <<EOT
region rClient {
  cell #{@ct_name}Client #{@cell_name} {
  };
};

region rServer {
  cell #{@ct_name}Server #{@cell_name}Server {
    #{@call_port_name} = #{@next_cell_name}.#{@next_cell_port_name};
    taskPriority = #{@task_priority};
    stack_size   = #{@stack_size};
  };
};
EOT
  end


  #=== ץ饰å
  # ץ饰å
  # (ҥ饹ǥС饤ɤ̻Ҥå)
  #ident:: string: ̻
  #rhs:: string: ʸ
  def check_plugin_arg( ident, rhs )
    proc = RPCPluginArgProc[ident.to_s]
    if proc.instance_of? Proc then
      proc.call( self, rhs )
    else
      params = ""
      delim = ""
      RPCPluginArgProc.each{ |j,p|
        params = "#{params}#{delim}#{j}"
        delim = ", "
      }
      Generator.error( "#{ident}: unknown plugin argument's identifier\n  #{params} are acceptible for RPCPlugin." )
    end
  end

  #=== ץ饰 taskPriority Υå
  def set_taskPriority( rhs )
    @task_priority = rhs
  end

  #=== ץ饰 serverChannelCelltype Υå
  def set_serverChannelCelltype( rhs )
    @serverChannel_celltype = rhs
    path = [ "::", rhs ]
    obj = Namespace.find( path )
    if ! obj.instance_of?( Celltype ) && ! obj.instance_of?( CompositeCelltype ) then
      Generator.error( "RPCPlugin: serverChanneclCelltype '#{rhs}' not celltype or not defined" )
    end
  end

  #=== ץ饰 clientChannelCelltype Υå
  def set_clientChannelCelltype( rhs )
    @clientChannel_celltype = rhs
    path = [ "::", rhs ]
    obj = Namespace.find( path )
    if ! obj.instance_of?( Celltype ) && ! obj.instance_of?( CompositeCelltype ) then
      Generator.error( "RPCPlugin: clientChanneclCelltype '#{rhs}' not celltype or not defined" )
    end
  end

  #===  taskCellype Υå
  def set_taskCelltype( rhs )
    @task_celltype = rhs
    path = [ "::", rhs ]
    obj = Namespace.find( path )
    if ! obj.instance_of?( Celltype ) && ! obj.instance_of?( CompositeCelltype ) then
      Generator.error( "RPCPlugin: taskCelltype '#{rhs}' not celltype or not defined" )
    end
  end

  #===  stack\size Υå
  def set_stack_size( rhs )
    @stack_size = rhs
  end
end


