#
#  TECS Generator
#      Generator for TOPPERS Embedded Component System
#  
#   Copyright (C) 2008-2009 by TOPPERS Project
#--
#   嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
#   ܥեȥѤΤޤࡥʲƱˤѡʣ
#   ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
#   (1) ܥեȥ򥽡ɤηѤˤϡ嵭
#       ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
#       ˴ޤޤƤ뤳ȡ
#   (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
#       ѤǤǺۤˤϡۤȼɥȡ
#       ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
#       ̵ݾڵǺܤ뤳ȡ
#   (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
#       ѤǤʤǺۤˤϡΤ줫ξ
#       ȡ
#     (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
#         ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
#     (b) ۤη֤̤ˡˤäơTOPPERSץȤ
#         𤹤뤳ȡ
#   (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
#       ⡤嵭ԤTOPPERSץȤդ뤳ȡ
#       ޤܥեȥΥ桼ޤϥɥ桼Τʤ
#       ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
#       դ뤳ȡ
#  
#   ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
#   TOPPERSץȤϡܥեȥ˴ؤơλŪ
#   ФŬޤơʤݾڤԤʤޤܥեȥ
#   ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
#   Ǥʤ
#  
#   $Id: RPCPlugin.rb 84 2008-05-04 14:19:09Z okuma-top $
#++

require_tecsgen_lib "GenTransparentMarshaler.rb"

#= Transparent RPC ץ饰
# Transparent RPC ͥ
# ץ饰ϰʲ RPCPluginArgProc 򻲾

# mikan through plugin: namespace θƤʤ
# Ѥ硢ʲΤ褦 toppers_jsp.cdl sChannel.cdl ꤹɬפ
# tecsgen toppers_jsp.cdl sChannel.cdl your_description.cdl

# ʲ»
#  ƤӸƤΥǥchar, short, int_t, long_t, intptr_t ΥƱ
#  ͭ桢̵ǥƱ

class RPCPlugin < ThroughPlugin

  # ץ饰̾ Proc
  RPCPluginArgProc = {
    "taskPriority"    => Proc.new { |obj,rhs| obj.set_taskPriority rhs },
    "channelCelltype" => Proc.new { |obj,rhs| obj.set_channelCelltype rhs },
    "channelCellName" => Proc.new { |obj,rhs| obj.set_channelCellName rhs },
    "PPAllocatorSize" => Proc.new { |obj,rhs| obj.set_PPAllocatorSize rhs }
  }

  include GenTransparentMarshaler

  #=== RPCPlugin  initialize
  #   ThroughPlugin (plugin.rb) 򻲾
  def initialize( cell_name, plugin_arg, next_cell_name, next_cell_port_name, signature_name, celltype )
    @task_priority = 8
    @channelCelltype = "tDataqueueOWChannel"
    @channelCellName = "#{cell_name}Channel"
    @PPAllocatorSize = nil
    super

    if @signature.need_PPAllocator? then
      if @PPAllocatorSize == nil then
        Generator.error( "PPAllocatorSize must be speicified for oneway [in] array" )
      end
    end

    @signature.each_param{ |func_decl, param_decl|
      if func_decl.get_type.is_oneway? then
        if ( param_decl.get_size || param_decl.get_count ) && param_decl.get_string then
          Generator.error( "array of string not supported for oneway function in Transparent RPC" )  # mikan ʸ
        elsif param_decl.get_string == -1 then
          Generator.error( "length unspecified string is not permited for oneway function in Transparent RPC" )  # mikan Ĺ̤ʸ
        end
      end
    }
  end

  #=== plugin  (celltype ) 
  def gen_plugin_decl_code( file )

    ct_name = "#{@ct_name}_#{@channelCelltype}"

    # Υ륿סƱ˥ˤϴƤ뤫
    if @@generated_celltype[ ct_name ] == nil then
      @@generated_celltype[ ct_name ] = [ self ]
    else
      @@generated_celltype[ ct_name ] << self
      return
    end

    sig_name = "#{@ct_name}"
    f = CFile.open( "#{$gen}/#{sig_name}.cdl", "w" )
    # ƱƤٽ񤯲ǽ (AppFile Բ)

    if @signature.need_PPAllocator? then
      alloc_call_port = "  call sPPAllocator cPPAllocator;\n"
      alloc_cell = "  cell tPPAllocator PPAllocator {\n  heapSize = #{@PPAllocatorSize}; };\n"
      alloc_call_port_join = "  cPPAllocator = PPAllocator.ePPAllocator;\n"
    else
      alloc_call_port = ""
      alloc_cell = ""
      alloc_call_port_join = ""
    end

    f.print <<EOT

celltype #{@ct_name}_marshaler {
  entry #{@signature.get_name} eClientEntry;
  call sTDR        cTDR;
  call sEventflag  cEventflag;
  [optional]
    call sSemaphore cLockChannel;  // this port is eliminated by optimize
};
celltype #{@ct_name}_unmarshaler {
  call #{@signature.get_name} cServerCall;
  call sTDR        cTDR;
  call sEventflag  cEventflag;
  entry sTaskBody  eUnmarshalAndCallFunction;
#{alloc_call_port}};
EOT
    f.close

    f = CFile.open( "#{$gen}/#{ct_name}.cdl", "w" )
    # ƱƤٽ񤯲ǽ (AppFile Բ)

    f.print <<EOT
import( "#{sig_name}.cdl" );

[active]
composite #{@ct_name} {
  /* Interface */
  attr {
    PRI taskPriority = 8;
  };
  call #{@signature.get_name} #{@call_port_name};
  entry #{@signature.get_name} eThroughEntry;

  call sTDR       cTDR;
  call sEventflag cEventflag;

  /* Implementation */
  cell #{@ct_name}_marshaler #{@signature.get_name}_marshaler{
    cTDR       => composite.cTDR;
    cEventflag => composite.cEventflag;
  };
#{alloc_cell}  cell #{@ct_name}_unmarshaler #{@signature.get_name}_unmarshaler{
    cTDR        => composite.cTDR;
    cEventflag  => composite.cEventflag;
    cServerCall => composite.#{@call_port_name};
#{alloc_call_port_join}  };
  cell tRPCDedicatedTaskMain RPCTaskMain{
    cMain = #{@signature.get_name}_unmarshaler.eUnmarshalAndCallFunction;
  };
  cell tTask Task {
    cBody     = RPCTaskMain.eMain;
    priority  = taskPriority;  /* mikan : ץ饤ƥ */
    taskAttribute = C_EXP( "TA_ACT" );  /* mikan : marshaler Ϻǽ餫鵯ư */
    stackSize     = 4096;
  };
  composite.eThroughEntry => #{@signature.get_name}_marshaler.eClientEntry;
};
EOT
    # mikan stackSize option & ǿ tecs_package б

    f.close
  end

  #===  through cell ɤ
  #
  #
  def gen_through_cell_code( file )

    gen_plugin_decl_code( file )

    # õ
    path =["::",@next_cell_name]
    cell = Namespace.find( path )

    file.print <<EOT
import( "#{$gen}/#{@ct_name}_#{@channelCelltype}.cdl" );

// ͥ륻
cell #{@channelCelltype} #{@channelCellName} {
};

// RPC ͥ륻
EOT

    # #473 褵줿硢composite 졼ѹ٤
    # λ꤬뤫
    if cell.get_allocator_list.length > 0

      file.print "[allocator("

      delim = ""
      cell.get_allocator_list.each do |eport, subsc, func, buf, alloc|

        file.print delim
        delim = ",\n"        # ǽԤˤϽФʤ

        if subsc then        # ź
          subsc_str = '[#{subsc}]'
        else
          subsc_str = ""
        end

        eport = "eThroughEntry" #RPCμ̾ѹ
        file.print  "#{eport}#{subsc_str}.#{func}.#{buf} = #{alloc}"
      end

      file.puts ")]"
    end

    file.print <<EOT
cell #{@ct_name} #{@cell_name} {
  #{@call_port_name} = #{@next_cell_name}.#{@next_cell_port_name};
  cTDR         = #{@channelCellName}.eTDR;
  cEventflag   = #{@channelCellName}.eEventflag;
  taskPriority = #{@task_priority};
};
EOT
  end

  #=== ץ饰å
  # ץ饰å
  # (ҥ饹ǥС饤ɤ̻Ҥå)
  #ident:: string: ̻
  #rhs:: string: ʸ
  def check_plugin_arg( ident, rhs )
    proc = RPCPluginArgProc[ident.to_s]
    if proc.instance_of? Proc then
      proc.call( self, rhs )
    else
      params = ""
      delim = ""
      RPCPluginArgProc.each{ |j,p|
        params = "#{params}#{delim}#{j}"
        delim = ", "
      }
      Generator.error( "#{ident}: unknown plugin argument's identifier\n  #{params} are acceptible for RPCPlugin." )
    end
  end

  #=== ץ饰 taskPriority Υå
  def set_taskPriority( rhs )
    @task_priority = rhs
  end

  #=== ץ饰 channelCelltype Υå
  def set_channelCelltype( rhs )
    @channelCelltype = rhs
    path = [ "::", rhs ]
    obj = Namespace.find( path )
    if ! obj.instance_of?( Celltype ) && ! obj.instance_of?( CompositeCelltype ) then
      Generator.error( "RPCPlugin: channeclCelltype '#{rhs}' not celltype or not defined" )
    end
  end

  def set_PPAllocatorSize( rhs )
    @PPAllocatorSize = rhs
  end

  #=== ץ饰 channelCellName Υå
  def set_channelCellName( rhs )
    @channelCellName = rhs
    if @channelCellName =~ /\A[a-zA-Z_]\w*/ then
      # OK
    else
      Generator.error( "RPCPlugin: channeclCellName '#{rhs}' unsuitable for identifier" )
    end
  end

end


