#
#  TECS Generator
#      Generator for TOPPERS Embedded Component System
#  
#   Copyright (C) 2008-2009 by TOPPERS Project
#--
#   嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
#   ܥեȥѤΤޤࡥʲƱˤѡʣ
#   ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
#   (1) ܥեȥ򥽡ɤηѤˤϡ嵭
#       ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
#       ˴ޤޤƤ뤳ȡ
#   (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
#       ѤǤǺۤˤϡۤȼɥȡ
#       ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
#       ̵ݾڵǺܤ뤳ȡ
#   (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
#       ѤǤʤǺۤˤϡΤ줫ξ
#       ȡ
#     (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
#         ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
#     (b) ۤη֤̤ˡˤäơTOPPERSץȤ
#         𤹤뤳ȡ
#   (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
#       ⡤嵭ԤTOPPERSץȤդ뤳ȡ
#       ޤܥեȥΥ桼ޤϥɥ桼Τʤ
#       ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
#       դ뤳ȡ
#  
#   ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
#   TOPPERSץȤϡܥեȥ˴ؤơλŪ
#   ФŬޤơʤݾڤԤʤޤܥեȥ
#   ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
#   Ǥʤ
#  
#   $Id: RPCPlugin.rb 84 2008-05-04 14:19:09Z okuma-top $
#++

require_tecsgen_lib "GenTransparentMarshaler.rb"

#= OpaqueRPC ץ饰
# OpaqueRPC ͥ
# ץ饰ϰʲ RPCPluginArgProc 򻲾

# mikan through plugin: namespace θƤʤ
# Ѥ硢ʲΤ褦 toppers_jsp.cdl sChannel.cdl ꤹɬפ
# tecsgen toppers_jsp.cdl sChannel.cdl your_description.cdl

# ʲ»
#  ƤӸƤΥǥchar, short, int_t, long_t, intptr_t ΥƱ
#  ͭ桢̵ǥƱ

class SharedRPCPlugin < ThroughPlugin

  # ץ饰̾ Proc
  RPCPluginArgProc = {
    "channelCelltype"   => Proc.new { |obj,rhs| obj.set_channelCelltype rhs },
    "sharedChannelCell" => Proc.new { |obj,rhs| obj.set_sharedChannelCell rhs },
    "PPAllocatorSize" => Proc.new { |obj,rhs| obj.set_PPAllocatorSize rhs }
  }

  @@shared_channel_list = {}
  attr_reader :cell_name, :channelCelltype
  include GenTransparentMarshaler

  #=== RPCPlugin  initialize
  #   ThroughPlugin (plugin.rb) 򻲾
  def initialize( cell_name, plugin_arg, next_cell_name, next_cell_port_name, signature, celltype )
    @channelCelltype = "tDataqueueOWChannel"
    @shared_channel_cell = ""
    super
    if @shared_channel_cell == "" then
      Generator.error( "SharedRPCPlugin: need sharedChannelCell option" )
    end

    if @@shared_channel_list[ @shared_channel_cell ] == nil then
      @@shared_channel_list[ @shared_channel_cell ] = [ self ]
    else
      @@shared_channel_list[ @shared_channel_cell ] << self
    end
    @sub_channel_no = ( @@shared_channel_list[ @shared_channel_cell ].length ) -1

    if @signature.need_PPAllocator? then
      if @PPAllocatorSize == nil then
        Generator.error( "PPAllocatorSize must be speicified for oneway [in] array" )
      end
    end

  end

  def gen_plugin_decl_code( file )

    @shared_channel_ct_name = "tSharedRPC_#{@channelCelltype}"

    # Υ륿סƱ˥ˤϴƤ뤫
    if @@generated_celltype[ @shared_channel_ct_name ] == nil then
      @@generated_celltype[ @shared_channel_ct_name ] = [ self ]
    else
      @@generated_celltype[ @shared_channel_ct_name ] << self
    end

    if @@generated_celltype[ @ct_name ] == nil then
      @@generated_celltype[ @ct_name ] = [ self ]
    else
      @@generated_celltype[ @ct_name ] << self
    end

    marshaler_cdl = "sSig_#{@ct_name}.cdl"
    f = CFile.open( "#{$gen}/#{marshaler_cdl}", "w" )
    # ƱƤٽ񤯲ǽ (AppFile Բ)

    f.print <<EOT

celltype #{@ct_name}_marshaler {
  entry #{@signature.get_name} eClientEntry;
  [optional]
    call sSemaphore cLockChannel;
  call sTDR       cTDR;
  call sEventflag cEventflag;
};
celltype #{@ct_name}_unmarshaler {
  call #{@signature.get_name} cServerCall;
  call  sTDR       cTDR;
  call  sEventflag cEventflag;
  entry sTaskBody  eUnmarshalAndCallFunction;
};
EOT
    f.close

    f = CFile.open( "#{$gen}/#{@ct_name}.cdl", "w" )
    # ƱƤٽ񤯲ǽ (AppFile Բ)

    f.print <<EOT
import( "#{marshaler_cdl}" );

composite #{@ct_name} {
  /* Interface */
  call  #{@signature.get_name} #{@call_port_name};
  entry #{@signature.get_name} eThroughEntry;
  call  sTDR       cTDR;
  call  sEventflag cEventflag;
  entry sTaskBody  eUnmarshalAndCallFunction;
  [optional]
    call sSemaphore cLockChannel;

  /* Implementation */
  cell #{@ct_name}_marshaler #{@signature.get_name}_marshaler{
    cTDR         => composite.cTDR;
    cEventflag   => composite.cEventflag;
    cLockChannel => composite.cLockChannel;
  };
  cell #{@ct_name}_unmarshaler #{@signature.get_name}_unmarshaler{
    cTDR         => composite.cTDR;
    cEventflag   => composite.cEventflag;
    cServerCall  => composite.#{@call_port_name};
  };
  composite.eThroughEntry => #{@signature.get_name}_marshaler.eClientEntry;
  composite.eUnmarshalAndCallFunction => #{@signature.get_name}_unmarshaler.eUnmarshalAndCallFunction;
};
EOT
    # mikan stackSize option & ǿ tecs_package б

    f.close

    f = CFile.open( "#{$gen}/#{@shared_channel_ct_name}.cdl", "w" )
    # ƱƤٽ񤯲ǽ (AppFile Բ)

    f.print <<EOT
[active]
composite #{@shared_channel_ct_name} {
  /* Interface */
  entry  sSemaphore eSemaphore[];
  call   sTaskBody  cUnmarshalAndCallFunction[];

  entry  sDataqueue eDataqueue;
  entry  sTDR       eTDR;
  entry  sEventflag eEventflag;

  /* Implementation */
  cell #{@channelCelltype} Channel{
  };
  cell tSemaphore Semaphore {count = 1; attribute = C_EXP("TA_NULL");};
  cell tRPCSharedTaskMain RPCSharedTaskMain {
    cUnmarshalAndCallFunction => composite.cUnmarshalAndCallFunction;
    cServerSideTDR            = Channel.eTDR;
  };
  cell tRPCSharedChannelMan RPCChannelMan {
    cSemaphore                = Semaphore.eSemaphore;
    cClientSideTDR            = Channel.eTDR;
  };
  cell tTask RPCSharedTask {
    cBody = RPCSharedTaskMain.eMain;
    taskAttribute = C_EXP("TA_ACT");
    priority   = 9;
    stackSize = 4096;
  };
  composite.eTDR           => Channel.eTDR;
  composite.eEventflag     => Channel.eEventflag;
  composite.eSemaphore     => RPCChannelMan.eSemaphore;
  composite.eDataqueue     => Channel.eDataqueue;
};
EOT
    f.close

  end

  #===  through cell ɤ
  #
  #
  def gen_through_cell_code( file )

    gen_plugin_decl_code( file )

    # õ
    path =["::",@next_cell_name]
    cell = Namespace.find( path )

    file.print <<EOT
import( "#{$gen}/#{@ct_name}.cdl" );
import( "#{$gen}/#{@shared_channel_ct_name}.cdl" );

cell #{@shared_channel_ct_name} #{@shared_channel_cell};
EOT

    # λ꤬뤫
    if cell.get_allocator_list.length > 0

      file.print "[allocator("

      delim = ""
      cell.get_allocator_list.each do |eport, subsc, func, buf, alloc|

        file.print delim
        delim = ",\n"        # ǽԤˤϽФʤ

        if subsc then        # ź
          subsc_str = '[#{subsc}]'
        else
          subsc_str = ""
        end

        eport = "eThroughEntry" #RPCμ̾ѹ
        file.print  "#{eport}#{subsc_str}.#{func}.#{buf} = #{alloc}"
      end

      file.puts ")]"
    end

    file.print <<EOT
cell #{@ct_name} #{@cell_name} {
  #{@call_port_name} = #{@next_cell_name}.#{@next_cell_port_name};
  cTDR         = #{@shared_channel_cell}.eTDR;
  cEventflag   = #{@shared_channel_cell}.eEventflag;
  cLockChannel =  #{@shared_channel_cell}.eSemaphore[#{@sub_channel_no}];
};
EOT
  end

  #=== ץ饰å
  # ץ饰å
  # (ҥ饹ǥС饤ɤ̻Ҥå)
  #ident:: string: ̻
  #rhs:: string: ʸ
  def check_plugin_arg( ident, rhs )
    proc = RPCPluginArgProc[ident.to_s]
    if proc.instance_of? Proc then
      proc.call( self, rhs )
    else
      params = ""
      delim = ""
      RPCPluginArgProc.each{ |j,p|
        params = "#{params}#{delim}#{j}"
        delim = ", "
      }
      Generator.error( "#{ident}: unknown plugin argument's identifier\n  #{params} are acceptible for RPCPlugin." )
    end
  end

  #=== ץ饰 channelCelltype Υå
  def set_channelCelltype( rhs )
    @channelCelltype = rhs
    path = [ "::", rhs ]
    obj = Namespace.find( path )
    if ! obj.instance_of?( Celltype ) && ! obj.instance_of?( CompositeCelltype ) then
      Generator.error( "RPCPlugin: channeclCelltype '#{rhs}' not celltype or not defined" )
    end
  end

  #=== ץ饰 channelCell Υå
  def set_sharedChannelCell( rhs )
    @shared_channel_cell = rhs
#    path = [ "::", rhs ]
#    obj = Namespace.find( path )
#    if ! obj.instance_of?( Cell ) then
#      Generator.error( "RPCPlugin: sharedChannelCell '#{rhs}' not cell" )
#    end
  end


  #=== Υɤ
  #ץ饰θΥɤ
  #file:: File: 
  def self.gen_post_code( file )
    file.print "/* '#{self.name}' post code */\n"
    @@shared_channel_list.each{ |chan_name,plugin_obj|
      file.print <<EOT
cell tSharedRPC_#{plugin_obj[0].channelCelltype} #{chan_name} {
EOT
      plugin_obj.each{ |po|
        file.print <<EOT
    cUnmarshalAndCallFunction[] = #{po.cell_name}.eUnmarshalAndCallFunction;
EOT
      }
      file.printf <<EOT
};
EOT
    }
  end

  def set_PPAllocatorSize( rhs )
    @PPAllocatorSize = rhs
  end
end


