/* #[<PREAMBLE>]#
 * #[<...>]#  #[</...>]# ǰϤޤ줿ȤԽʤǤ
 * tecsmerge ˤޡ˻Ѥޤ
 *
 * #[</PREAMBLE>]# */

/* ؿ #_TEPF_# */
/* #[<ENTRY_PORT>]# eChannel
 * entry port: eChannel
 * signature:  sChannel
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eChannel_open
 * name:         eChannel_open
 * global_name:  tDataqueueAdaptor_eChannel_open
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline ER
eChannel_open(CELLIDX idx, const int8_t* arg, int16_t size, TMO tmo)
{
	ER		ercd = E_OK;
	CELLCB	*p_cellcb;
	if (VALID_IDX(idx)) {
		p_cellcb = GET_CELLCB(idx);
	}
	else {
		return(E_ID);
	}

	/* ˽Τ򵭽Ҥޤ #_TEFB_# */

	return(ercd);
}

/* #[<ENTRY_FUNC>]# eChannel_close
 * name:         eChannel_close
 * global_name:  tDataqueueAdaptor_eChannel_close
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline ER
eChannel_close(CELLIDX idx)
{
	ER		ercd = E_OK;
	CELLCB	*p_cellcb;
	if (VALID_IDX(idx)) {
		p_cellcb = GET_CELLCB(idx);
	}
	else {
		return(E_ID);
	}

	/* ˽Τ򵭽Ҥޤ #_TEFB_# */

	return(ercd);
}

/* #[<ENTRY_FUNC>]# eChannel_reset
 * name:         eChannel_reset
 * global_name:  tDataqueueAdaptor_eChannel_reset
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline ER
eChannel_reset(CELLIDX idx)
{
	ER		ercd = E_OK;
	CELLCB	*p_cellcb;
	if (VALID_IDX(idx)) {
		p_cellcb = GET_CELLCB(idx);
	}
	else {
		return(E_ID);
	}

	/* ˽Τ򵭽Ҥޤ #_TEFB_# */
	cEventflag_clear( 0 );

	return(ercd);
}

/* #[<ENTRY_FUNC>]# eChannel_send
 * name:         eChannel_send
 * global_name:  tDataqueueAdaptor_eChannel_send
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline ER
eChannel_send(CELLIDX idx, const int8_t* buf, int16_t size, TMO tmo)
{
	ER		ercd = E_OK;
	CELLCB	*p_cellcb;
	int     i;
	if (VALID_IDX(idx)) {
		p_cellcb = GET_CELLCB(idx);
	}
	else {
		return(E_ID);
	}

	/* ˽Τ򵭽Ҥޤ #_TEFB_# */
	ercd = 0;
	for( i = 0; i < size; i++ )
		ercd |= cDataqueue_send( (intptr_t)((uint8_t)buf[ i ]) );

	return(ercd);
}

/* #[<ENTRY_FUNC>]# eChannel_flush
 * name:         eChannel_flush
 * global_name:  tDataqueueAdaptor_eChannel_flush
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline ER
eChannel_flush(CELLIDX idx)
{
	ER		ercd = E_OK;
	CELLCB	*p_cellcb;
	if (VALID_IDX(idx)) {
		p_cellcb = GET_CELLCB(idx);
	}
	else {
		return(E_ID);
	}

	/* ˽Τ򵭽Ҥޤ #_TEFB_# */

	return(ercd);
}

/* #[<ENTRY_FUNC>]# eChannel_receive
 * name:         eChannel_receive
 * global_name:  tDataqueueAdaptor_eChannel_receive
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline ER_UINT
eChannel_receive(CELLIDX idx, int8_t* buf, int16_t size, TMO tmo)
{
	ER_UINT ercd = E_OK;
	CELLCB	*p_cellcb;
	intptr_t data;
	int     i;
	if (VALID_IDX(idx)) {
		p_cellcb = GET_CELLCB(idx);
	}
	else {
		return(E_ID);
	}

	/* ˽Τ򵭽Ҥޤ #_TEFB_# */
	/* printf( "DQA: receive(%d) ", size ); */
	for( i = 0; i < size; i++ ){
		ercd = cDataqueue_receive( &data );
		buf[i] = (int8_t)data;
		if( ercd != E_OK )
			break;
	}
	if( ercd != E_OK )
		return(ercd);
	else
		return i;
}

/* #[<ENTRY_FUNC>]# eChannel_end_receive
 * name:         eChannel_end_receive
 * global_name:  tDataqueueAdaptor_eChannel_end_receive
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline ER
eChannel_end_receive(CELLIDX idx)
{
	ER		ercd = E_OK;
	CELLCB	*p_cellcb;
	if (VALID_IDX(idx)) {
		p_cellcb = GET_CELLCB(idx);
	}
	else {
		return(E_ID);
	}

	/* ˽Τ򵭽Ҥޤ #_TEFB_# */

	return(ercd);
}

