/*
 * Υե tecsgen ˤƥץ졼ȤȤƼưޤ
 * ΥեԽƻѤ뤳ȤտޤƤޤ
 * tecsgen κƼ¹Ԥˤ񤭤Ƥޤᡢ̾
 *   gen/tPPAllocator_template.c => src/tPPAllocator.c
 * Τ褦̾, եѹƤ齤ޤ
 */
/* #[<PREAMBLE>]#
 * #[<...>]#  #[</...>]# ǰϤޤ줿ȤԽʤǤ
 * tecsmerge ˤޡ˻Ѥޤ
 *
 * °ޥ #_CAAM_#
 * heap_size        uint32_t         ATTR_heap_size  
 * buf              int8_t*          VAR_buf         
 * allocated_size   uint32_t         VAR_allocated_size
 *
 * #[</PREAMBLE>]# */

#include "tPPAllocator_tecsgen.h"

#ifndef E_OK
#define	E_OK	0		/* success */
#define	E_ID	(-18)	/* illegal ID */
#endif

/* ؿ #_TEPF_# */
/* #[<ENTRY_PORT>]# ePPAllocator
 * entry port: ePPAllocator
 * signature:  sPPAllocator
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# ePPAllocator_alloc
 * name:         ePPAllocator_alloc
 * global_name:  tPPAllocator_ePPAllocator_alloc
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
ER
ePPAllocator_alloc(CELLIDX idx, uint32_t size, void** ptr)
{
	ER		ercd = E_OK;
	CELLCB	*p_cellcb;
	if (VALID_IDX(idx)) {
		p_cellcb = GET_CELLCB(idx);
	}
	else {
		return(E_ID);
	}

	/* ˽Τ򵭽Ҥޤ #_TEFB_# */
	if( size + VAR_allocatedSize > ATTR_heapSize ){
		ercd = E_NOMEM;
	}
	else {
		*ptr = (void *)(VAR_buf+VAR_allocatedSize);
		VAR_allocatedSize += size;
	}

	return(ercd);
}

/* #[<ENTRY_FUNC>]# ePPAllocator_dealloc
 * name:         ePPAllocator_dealloc
 * global_name:  tPPAllocator_ePPAllocator_dealloc
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
ER
ePPAllocator_dealloc(CELLIDX idx, const void* ptr)
{
	ER		ercd = E_OK;
	CELLCB	*p_cellcb;
	if (VALID_IDX(idx)) {
		p_cellcb = GET_CELLCB(idx);
	}
	else {
		return(E_ID);
	}

	/* ˽Τ򵭽Ҥޤ #_TEFB_# */
	if( (uintptr_t)ptr < (uintptr_t)VAR_buf || (uintptr_t)ptr >= (uintptr_t)(VAR_buf+VAR_allocatedSize) ){
		ercd = E_PAR;
	}
	else {
		VAR_allocatedSize = (uintptr_t)ptr - (uintptr_t)VAR_buf;
	}

	return(ercd);
}

/* #[<ENTRY_FUNC>]# ePPAllocator_dealloc_all
 * name:         ePPAllocator_dealloc_all
 * global_name:  tPPAllocator_ePPAllocator_dealloc_all
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
ER
ePPAllocator_dealloc_all(CELLIDX idx)
{
	ER		ercd = E_OK;
	CELLCB	*p_cellcb;
	if (VALID_IDX(idx)) {
		p_cellcb = GET_CELLCB(idx);
	}
	else {
		return(E_ID);
	}

	/* ˽Τ򵭽Ҥޤ #_TEFB_# */
	VAR_allocatedSize = 0;

	return(ercd);
}

/* #[<POSTAMBLE>]#
 *   겼ؿ񤭤ޤ
 * #[</POSTAMBLE>]#*/
