/*
 *  ͭѤϡեǥ塼ץåͥ
 *   in 
 */

/* #[<PREAMBLE>]#
 * #[<...>]#  #[</...>]# ǰϤޤ줿ȤԽʤǤ
 * tecsmerge ˤޡ˻Ѥޤ
 *
 * °ޥ #_CAAM_#
 * size             int32_t          ATTR_size       
 * buf              int8_t*          VAR_buf         
 * count            int32_t          VAR_count       
 * rp               int32_t          VAR_rp          
 * b_reset1         bool_t           VAR_b_reset1    
 * b_reset2         bool_t           VAR_b_reset2    
 *
 * ƤӸؿ #_TCPF_#
 * call port : cSem  signature: sSemaphore context: task
 *   ER             cSem_signal( );
 *   ER             cSem_wait( );
 *   ER             cSem_waitPolling( );
 *   ER             cSem_waitTimeout( TMO timeout );
 *   ER             cSem_initialize( );
 *   ER             cSem_refer( T_RSEM* pk_semaphore_status );
 * call port : cFlg  signature: sEventflag context: task
 *   ER             cFlg_set( FLGPTN set_pattern );
 *   ER             cFlg_clear( FLGPTN clear_pattern );
 *   ER             cFlg_wait( FLGPTN wait_pattern, MODE wait_flag_mode, FLGPTN* p_flag_pattern );
 *   ER             cFlg_waitPolling( FLGPTN wait_pattern, MODE wait_flag_mode, FLGPTN* p_flag_pattern );
 *   ER             cFlg_waitTimeout( FLGPTN wait_pattern, MODE wait_flag_mode, FLGPTN* p_flag_pattern, TMO timeout );
 *   ER             cFlg_initialize( );
 *   ER             cFlg_refer( T_RFLG* pk_eventflag_status );
 * require port : signature: sKernel context: task
 *   ER             sleep( );
 *   ER             sleepTimeout( TMO timeout );
 *   ER             delay( RELTIM delay_time );
 *   ER             exitTask( );
 *   ER             getTaskId( ID* p_task_id );
 *   ER             rotateReadyQueue( PRI task_priority );
 *   ER             getTime( SYSTIM* p_system_time );
 *   ER             getMicroTime( SYSUTM* p_system_micro_time );
 *   ER             lockCpu( );
 *   ER             unlockCpu( );
 *   ER             disableDispatch( );
 *   ER             enableDispatch( );
 *   ER             disableTaskException( );
 *   ER             enableTaskException( );
 *   ER             changeInterruptPriorityMask( PRI interrupt_priority );
 *   ER             getInterruptPriorityMask( PRI* p_interrupt_priority );
 *   ER             exitKernel( );
 *   bool_t         senseContext( );
 *   bool_t         senseLock( );
 *   bool_t         senseDispatch( );
 *   bool_t         senseDispatchPendingState( );
 *   bool_t         senseKernel( );
 *
 * #[</PREAMBLE>]# */

#include "tShmemHDChannelBuf_tecsgen.h"

#ifndef TECS
static inline void memcpy( void *to, const void *from, size_t size )
{
	char  *t = to, *f = from;
	while( size > 0 ){
		*t++ = *f++;
		size--;
	}
}
#endif

static ER       tShmemHDChan_send_wait( TSHMEMHDCHAN_CH ch, tShmemHDChannelBuf_CB *p_cellcb, TMO tmo );
static ER       tShmemHDChan_recv_wait( TSHMEMHDCHAN_CH ch, tShmemHDChannelBuf_CB *p_cellcb, TMO tmo );
static ER       tShmemHDChan_write_buf( tShmemHDChannelBuf_CB *p_cellcb, const int_least8_t *buf, int16_t size );
static ER_UINT  tShmemHDChan_read_buf(  tShmemHDChannelBuf_CB *p_cellcb, int_least8_t *buf, int16_t size );
static void     tShmemHDChan_end_receive( tShmemHDChannelBuf_CB *p_cellcb );

#ifndef E_OK
#define	E_OK	0		/* success */
#define	E_ID	(-18)	/* illegal ID */
#endif

/* ؿ #_TEPF_# */
/* #[<ENTRY_PORT>]# eC0
 * entry port: eC0
 * signature:  sChannel
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eC0_open
 * name:         eC0_open
 * global_name:  tShmemHDChannelBuf_eC0_open
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
ER
eC0_open(CELLIDX idx, const int8_t* arg, int16_t size, TMO tmo)
{
	ER		ercd = E_OK;
	CELLCB	*p_cellcb;
	if (VALID_IDX(idx)) {
		p_cellcb = GET_CELLCB(idx);
	}
	else {
		return(E_ID);
	}

	/* ˽Τ򵭽Ҥޤ #_TEFB_# */
  	(void)cSem_wait();
	(void)cFlg_clear( 0x0 );
	(void)cFlg_set( TSHMEMHDCHAN_FLG_WAIT );
	(void)cSem_signal();

	return(ercd);
}

/* #[<ENTRY_FUNC>]# eC0_close
 * name:         eC0_close
 * global_name:  tShmemHDChannelBuf_eC0_close
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
ER
eC0_close(CELLIDX idx)
{
	ER		ercd = E_OK;
	CELLCB	*p_cellcb;
	if (VALID_IDX(idx)) {
		p_cellcb = GET_CELLCB(idx);
	}
	else {
		return(E_ID);
	}

	/* ˽Τ򵭽Ҥޤ #_TEFB_# */

	return(ercd);
}

/* #[<ENTRY_FUNC>]# eC0_reset
 * name:         eC0_reset
 * global_name:  tShmemHDChannelBuf_eC0_reset
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
ER
eC0_reset(CELLIDX idx)
{
	ER		ercd = E_OK;
	CELLCB	*p_cellcb;
	if (VALID_IDX(idx)) {
		p_cellcb = GET_CELLCB(idx);
	}
	else {
		return(E_ID);
	}

	/* ˽Τ򵭽Ҥޤ #_TEFB_# */
	VAR_b_reset2 = false;
	VAR_b_reset1 = true;

	return(ercd);
}

/* #[<ENTRY_FUNC>]# eC0_send
 * name:         eC0_send
 * global_name:  tShmemHDChannelBuf_eC0_send
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
ER
eC0_send(CELLIDX idx, const int8_t* buf, int16_t size, TMO tmo)
{
	ER		ercd = E_OK;
	CELLCB	*p_cellcb;
	if (VALID_IDX(idx)) {
		p_cellcb = GET_CELLCB(idx);
	}
	else {
		return(E_ID);
	}

	/* ˽Τ򵭽Ҥޤ #_TEFB_# */
	/* channel 1 񤭤ǤΤԤ */
//  syslog( LOG_INFO, "Shmem: send: waiting" );
	if( ( ercd = tShmemHDChan_send_wait( 0, p_cellcb, tmo ) ) != E_OK ){
		syslog( LOG_INFO, "Shmem: send: waiting NG er:%d", ercd );
		return  ercd;
	}

	/* Хåե˽񤭤 */
//  syslog( LOG_INFO, "Shmem: send: writing" );
    tShmemHDChan_write_buf( p_cellcb, buf, size );

	return(ercd);
}

/* #[<ENTRY_FUNC>]# eC0_flush
 * name:         eC0_flush
 * global_name:  tShmemHDChannelBuf_eC0_flush
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
ER
eC0_flush(CELLIDX idx)
{
	ER		ercd = E_OK;
	CELLCB	*p_cellcb;
	if (VALID_IDX(idx)) {
		p_cellcb = GET_CELLCB(idx);
	}
	else {
		return(E_ID);
	}

	/* ˽Τ򵭽Ҥޤ #_TEFB_# */
	if( VAR_b_reset2 == true ){
		VAR_b_reset2 = false;
		return  E_RESET;
	}

	cFlg_clear( 0x0 );
	cFlg_set( TSHMEMHDCHAN_FLG_RCV1 );

	return(ercd);
}

/* #[<ENTRY_FUNC>]# eC0_receive
 * name:         eC0_receive
 * global_name:  tShmemHDChannelBuf_eC0_receive
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
ER_UINT
eC0_receive(CELLIDX idx, int8_t* buf, int16_t size, TMO tmo)
{
	FLGPTN   flgptn;
	ER_UINT  er_sz;
	CELLCB	*p_cellcb;
	if (VALID_IDX(idx)) {
		p_cellcb = GET_CELLCB(idx);
	}
	else {
		return(E_ID);
	}

	/* ˽Τ򵭽Ҥޤ #_TEFB_# */
	if( VAR_b_reset2 == true ){
		VAR_b_reset2 = false;
		return  E_RESET;
	}

	/* Ԥ */
    if( ( er_sz = tShmemHDChan_recv_wait( 0, p_cellcb, tmo ) ) != E_OK )
		return  er_sz;

	/* Хåեɤ߽Ф */
    er_sz = tShmemHDChan_read_buf( p_cellcb, buf, size );

	return(er_sz);
}

/* #[<ENTRY_FUNC>]# eC0_end_receive
 * name:         eC0_end_receive
 * global_name:  tShmemHDChannelBuf_eC0_end_receive
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
ER
eC0_end_receive(CELLIDX idx)
{
	ER		ercd = E_OK;
	CELLCB	*p_cellcb;
	if (VALID_IDX(idx)) {
		p_cellcb = GET_CELLCB(idx);
	}
	else {
		return(E_ID);
	}

	/* ˽Τ򵭽Ҥޤ #_TEFB_# */
	tShmemHDChan_end_receive( p_cellcb );
	return(ercd);
}

/* #[<ENTRY_PORT>]# eC1
 * entry port: eC1
 * signature:  sChannel
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eC1_open
 * name:         eC1_open
 * global_name:  tShmemHDChannelBuf_eC1_open
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
ER
eC1_open(CELLIDX idx, const int8_t* arg, int16_t size, TMO tmo)
{
	ER		ercd = E_OK;
	CELLCB	*p_cellcb;
	if (VALID_IDX(idx)) {
		p_cellcb = GET_CELLCB(idx);
	}
	else {
		return(E_ID);
	}

	/* ˽Τ򵭽Ҥޤ #_TEFB_# */

	return(ercd);
}

/* #[<ENTRY_FUNC>]# eC1_close
 * name:         eC1_close
 * global_name:  tShmemHDChannelBuf_eC1_close
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
ER
eC1_close(CELLIDX idx)
{
	ER		ercd = E_OK;
	CELLCB	*p_cellcb;
	if (VALID_IDX(idx)) {
		p_cellcb = GET_CELLCB(idx);
	}
	else {
		return(E_ID);
	}

	/* ˽Τ򵭽Ҥޤ #_TEFB_# */

	return(ercd);
}

/* #[<ENTRY_FUNC>]# eC1_reset
 * name:         eC1_reset
 * global_name:  tShmemHDChannelBuf_eC1_reset
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
ER
eC1_reset(CELLIDX idx)
{
	ER		ercd = E_OK;
	CELLCB	*p_cellcb;
	if (VALID_IDX(idx)) {
		p_cellcb = GET_CELLCB(idx);
	}
	else {
		return(E_ID);
	}

	/* ˽Τ򵭽Ҥޤ #_TEFB_# */
	VAR_b_reset2 = true;

	return(ercd);
}

/* #[<ENTRY_FUNC>]# eC1_send
 * name:         eC1_send
 * global_name:  tShmemHDChannelBuf_eC1_send
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
ER
eC1_send(CELLIDX idx, const int8_t* buf, int16_t size, TMO tmo)
{
	ER		ercd = E_OK;
	CELLCB	*p_cellcb;
	if (VALID_IDX(idx)) {
		p_cellcb = GET_CELLCB(idx);
	}
	else {
		return(E_ID);
	}

	/* ˽Τ򵭽Ҥޤ #_TEFB_# */
	/* channel 1 񤭤ǤΤԤ */
    if( ( ercd = tShmemHDChan_send_wait( 1, p_cellcb, tmo ) ) != E_OK )
		return  ercd;

	/* Хåե˽񤭤 */
    tShmemHDChan_write_buf( p_cellcb, buf, size );

	return(ercd);
}

/* #[<ENTRY_FUNC>]# eC1_flush
 * name:         eC1_flush
 * global_name:  tShmemHDChannelBuf_eC1_flush
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
ER
eC1_flush(CELLIDX idx)
{
	ER		ercd = E_OK;
	CELLCB	*p_cellcb;
	if (VALID_IDX(idx)) {
		p_cellcb = GET_CELLCB(idx);
	}
	else {
		return(E_ID);
	}

	/* ˽Τ򵭽Ҥޤ #_TEFB_# */
	cFlg_clear( 0x0 );
	cFlg_set( TSHMEMHDCHAN_FLG_RCV0 );

	return(ercd);
}

/* #[<ENTRY_FUNC>]# eC1_receive
 * name:         eC1_receive
 * global_name:  tShmemHDChannelBuf_eC1_receive
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
ER_UINT
eC1_receive(CELLIDX idx, int8_t* buf, int16_t size, TMO tmo)
{
	ER		er_sz;
	CELLCB	*p_cellcb;
	if (VALID_IDX(idx)) {
		p_cellcb = GET_CELLCB(idx);
	}
	else {
		return(E_ID);
	}

	/* ˽Τ򵭽Ҥޤ #_TEFB_# */
	if( VAR_b_reset2 == true ){
		VAR_b_reset2 = false;
		return  E_RESET;
	}

	/* Ԥ */
    if( ( er_sz = tShmemHDChan_recv_wait( 1, p_cellcb, tmo ) ) != E_OK )
		return  er_sz;

	/* Хåեɤ߽Ф */
    er_sz = tShmemHDChan_read_buf( p_cellcb, buf, size );

	return(er_sz);
}

/* #[<ENTRY_FUNC>]# eC1_end_receive
 * name:         eC1_end_receive
 * global_name:  tShmemHDChannelBuf_eC1_end_receive
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
ER
eC1_end_receive(CELLIDX idx)
{
	ER		ercd = E_OK;
	CELLCB	*p_cellcb;
	if (VALID_IDX(idx)) {
		p_cellcb = GET_CELLCB(idx);
	}
	else {
		return(E_ID);
	}

	/* ˽Τ򵭽Ҥޤ #_TEFB_# */
	tShmemHDChan_end_receive( p_cellcb );

	return(ercd);
}

/* #[<POSTAMBLE>]#
 *   겼ؿ񤭤ޤ
 * #[</POSTAMBLE>]#*/


/*
 * name:  tShmemHDChan_send_wait
 * param: IN FLGPTN snd_flgptn   TSHMEMHDCHAN_FLG_SND0 or TSHMEMHDCHAN_FLG_SND1
 * param: IN TMO    tmo          ॢȻ
 * REM:
 *  Ԥ
 *     cFlg  snd_flgptn ξ֤ΤȤľ E_OK ֤
 *    cFlg  TSHMEMHDCHAN_FLG_WAIT ΤȤcFlg  snd_flgptn ѹ (κ cSem ¾椹)
 *  tmo ǸƤӽФġΥƥॳϤ뤿ᡢǰξ tmo Ķ뤳Ȥꤦ
 *  ʤΤ褦ʤȤΤϡޤ졥 mikan ¬ꤷॢȤˤ٤
 */
static ER  tShmemHDChan_send_wait( TSHMEMHDCHAN_CH ch, tShmemHDChannelBuf_CB *p_cellcb, TMO tmo )
{
	FLGPTN     flgptn;
	ER         ercd;
	bool_t     b_ready = false;
	static     snd_flgptn[] = { TSHMEMHDCHAN_FLG_SND0, TSHMEMHDCHAN_FLG_SND1 };

// puts("Shmem: send_wait");
	/* ǤƤ뤫 */
	if( ( ercd = cFlg_waitTimeout( snd_flgptn[ch], TWF_ANDW, &flgptn, TMO_POL ) ) != E_TMOUT ){
		/* E_OK ޤϡ顼(return ) */

	}else{
		/* ޤ֤ˤʤäƤʤ */

		do {
// puts("Shmem: send_wait 1");
			/* ̤Ѿ֤ˤʤΤԤġ */
//	syslog( LOG_INFO, "cFlg_waitTimeout in tShmemHDChan send_wait" );
			if( ( ercd = cFlg_waitTimeout( TSHMEMHDCHAN_FLG_WAIT, TWF_ANDW, &flgptn, tmo ) ) == E_OK){

				/* ƱԤ */
//	syslog( LOG_INFO, "tShmemHalf: waiting sem 2" );
				if( ( ercd = cSem_waitTimeout( tmo ) ) != E_OK ){
					/* ॢȤ顼Ǥڤ */
					break;
				}

// puts("Shmem: send_wait 2");
				/* ̤Ѿ֤ ʥޥեޤǤ˥åȤƤʤå */
				if( ( ercd = cFlg_waitTimeout( TSHMEMHDCHAN_FLG_WAIT, TWF_ANDW, &flgptn, TMO_POL ) ) == E_OK ){
					/* ե饰򥻥å */
					(void)cFlg_clear( 0x0 );
					(void)cFlg_set( snd_flgptn[ch] );
					b_ready = true;
				}

				/* */  
				(void)cSem_signal();
			} else {
				/* 顼ʴޤ E_TMOUT) */
				break;
			}
		}while( b_ready == false );
	}
// puts("send_wait: done");
	return ercd;
}

/*
 * name:  tShmemHDChan_recv_wait
 * param: IN TMO    tmo          ॢȻ
 * REM:
 *  Ԥ
 *  ̾ tmo ǸƤӽФġΥƥॳϤ뤿ᡢǰξ tmo Ķ뤳Ȥꤦ
 *  ʤΤ褦ʤȤΤϡޤ
 */
static ER  tShmemHDChan_recv_wait( TSHMEMHDCHAN_CH ch, tShmemHDChannelBuf_CB *p_cellcb, TMO tmo )
{
	FLGPTN     flgptn;
	ER         ercd;
	static     rcv_flgptn[] = { TSHMEMHDCHAN_FLG_RCV0, TSHMEMHDCHAN_FLG_RCV1 };

	/* ǤƤ뤫 */
	ercd = cFlg_waitTimeout( rcv_flgptn[ch], TWF_ANDW, &flgptn, tmo );
		/* E_OK ޤϡ顼(return ) */
	return ercd;
}


static ER    tShmemHDChan_write_buf( tShmemHDChannelBuf_CB *p_cellcb, const int_least8_t *buf, int16_t size )
{
	ER   ercd;

	/* ХåեĶ񤭹ߤ ? */
	if( VAR_rp + size >= ATTR_size )
		ercd = E_BOVR;
	else {
		memcpy( &VAR_buf[ VAR_count ], buf, size );
		VAR_count += size;
		ercd = E_OK;
	}
	return ercd;
}


static ER_UINT   tShmemHDChan_read_buf( tShmemHDChannelBuf_CB *p_cellcb, int_least8_t *buf, int16_t size )
{
	/* ɽФĹη */
	if( VAR_rp + size > VAR_count )
		size = VAR_count - VAR_rp;

	memcpy( buf, &VAR_buf[ VAR_rp ], size );
	VAR_rp += size;

	return (ER_UINT)size;
}

static  void     tShmemHDChan_end_receive( tShmemHDChannelBuf_CB *p_cellcb )
{
//	syslog( LOG_INFO, "tShmemHalf: waiting sem 3" );
	(void)cSem_waitTimeout(TMO_FEVR);
	(void)cFlg_clear( 0x0 );
	(void)cFlg_set( TSHMEMHDCHAN_FLG_WAIT );
	(void)cSem_signal();
}

