/* #[<PREAMBLE>]#
 * #[<...>]#  #[</...>]# ǰϤޤ줿ȤԽʤǤ
 * tecsmerge ˤޡ˻Ѥޤ
 *
 * Υե tecsgen ˤƥץ졼ȤȤƼưޤ
 * ΥեԽƻѤ뤳ȤտޤƤޤ
 * tecsgen κƼ¹Ԥˤ񤭤Ƥޤᡢ̾
 *   gen/tThroughComponent_template.c => src/tThroughComponent.c
 * Τ褦̾, եѹƤ齤ޤ
 *
 * ƤӸؿ #_TCPF_#
 * call port : cSR  signature: sSendRecv context: task
 *   ER             cSR_snd( int8_t* buf, int32_t sz );
 *   ER             cSR_rcv( int8_t** buf, int32_t* sz );
 * allocator port for call port: eS func: snd param: buf
 *   ER             eS_snd_buf_alloc( int32_t size, void** p );
 *   ER             eS_snd_buf_dealloc( const void* p );
 * allocator port for call port: eS func: rcv param: buf
 *   ER             eS_rcv_buf_alloc( int32_t size, void** p );
 *   ER             eS_rcv_buf_dealloc( const void* p );
 * allocator port for call port: eA func: snd param: buf
 *   ER             eA_snd_buf_alloc( subscript, int32_t size, void** p );
 *   ER             eA_snd_buf_dealloc( subscript, const void* p );
 * allocator port for call port: eA func: rcv param: buf
 *   ER             eA_rcv_buf_alloc( subscript, int32_t size, void** p );
 *   ER             eA_rcv_buf_dealloc( subscript, const void* p );
 * allocator port for call port: cSR func: snd param: buf
 *   ER             cSR_snd_buf_alloc( int32_t size, void** p );
 *   ER             cSR_snd_buf_dealloc( const void* p );
 * allocator port for call port: cSR func: rcv param: buf
 *   ER             cSR_rcv_buf_alloc( int32_t size, void** p );
 *   ER             cSR_rcv_buf_dealloc( const void* p );
 *
 * #[</PREAMBLE>]# */

#include "tThroughComponent_tecsgen.h"

#ifndef E_OK
#define	E_OK	0		/* ｪλ */
#define	E_ID	(-18)	/* IDֹ */
#endif

/* ؿ #_TEPF_# */
/* #[<ENTRY_PORT>]# eS
 * entry port: eS
 * signature:  sSendRecv
 * context:    task
 * params: 
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eS_snd
 * name:         eS_snd
 * global_name:  tThroughComponent_eS_snd
 * oneway:       
 * #[/ENTRY_FUNC>]# */
ER
eS_snd(CELLIDX idx, int8_t* buf, int32_t sz)
{
	ER		ercd = E_OK;
	CELLCB	*p_cellcb;
	if (VALID_IDX(idx)) {
		p_cellcb = GET_CELLCB(idx);
	}
	else {
		return(E_ID);
	}

	/* ˽Τ򵭽Ҥޤ */
	cSR_snd( buf, sz );
	return(ercd);
}

/* #[<ENTRY_FUNC>]# eS_rcv
 * name:         eS_rcv
 * global_name:  tThroughComponent_eS_rcv
 * oneway:       
 * #[/ENTRY_FUNC>]# */
ER
eS_rcv(CELLIDX idx, int8_t** buf, int32_t* sz)
{
	ER		ercd = E_OK;
	CELLCB	*p_cellcb;
	if (VALID_IDX(idx)) {
		p_cellcb = GET_CELLCB(idx);
	}
	else {
		return(E_ID);
	}

	/* ˽Τ򵭽Ҥޤ */
	cSR_rcv( buf, sz );

	return(ercd);
}

/* #[<ENTRY_PORT>]# eA
 * entry port: eA
 * signature:  sSendRecv
 * context:    task
 * params: 
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eA_snd
 * name:         eA_snd
 * global_name:  tThroughComponent_eA_snd
 * oneway:       
 * #[/ENTRY_FUNC>]# */
ER
eA_snd(CELLIDX idx, int_t subscript, int8_t* buf, int32_t sz)
{
	ER		ercd = E_OK;
	CELLCB	*p_cellcb;
	if (VALID_IDX(idx)) {
		p_cellcb = GET_CELLCB(idx);
	}
	else {
		return(E_ID);
	}

	/* ˽Τ򵭽Ҥޤ */
	cSR_snd( buf, sz );

	return(ercd);
}

/* #[<ENTRY_FUNC>]# eA_rcv
 * name:         eA_rcv
 * global_name:  tThroughComponent_eA_rcv
 * oneway:       
 * #[/ENTRY_FUNC>]# */
ER
eA_rcv(CELLIDX idx, int_t subscript, int8_t** buf, int32_t* sz)
{
	ER		ercd = E_OK;
	CELLCB	*p_cellcb;
	if (VALID_IDX(idx)) {
		p_cellcb = GET_CELLCB(idx);
	}
	else {
		return(E_ID);
	}

	/* ˽Τ򵭽Ҥޤ */
	cSR_rcv( buf, sz );

	return(ercd);
}

