/*
 * ̃t@C tecsgen ɂev[gƂĎ܂
 * ̃t@CҏWĎgp邱ƂӐ}Ă܂
 * tecsgen ̍Ďsɂ㏑Ă܂߁Aʏ
 *   gen/tStarterTaskBody_template.c => src/tStarterTaskBody.c
 * ̂悤ɖO, tH_ύXĂC܂
 */
/* #[<PREAMBLE>]#
 * #[<...>]#  #[</...>]# ň͂܂ꂽRg͕ҏWȂł
 * tecsmerge ɂ}[WɎgp܂
 *
 * Ăь֐ #_TCPF_#
 * require port : signature: sKernel context: task
 *   ER             sleep( );
 *   ER             sleepTimeout( TMO timeout );
 *   ER             delay( RELTIM delayTime );
 *   ER             exitTask( );
 *   ER             getTaskId( ID* p_taskId );
 *   ER             rotateReadyQueue( PRI taskPriority );
 *   ER             getTime( SYSTIM* p_systemTime );
 *   ER             getMicroTime( SYSUTM* p_systemMicroTime );
 *   ER             lockCpu( );
 *   ER             unlockCpu( );
 *   ER             disableDispatch( );
 *   ER             enableDispatch( );
 *   ER             disableTaskException( );
 *   ER             enableTaskException( );
 *   ER             changeInterruptPriorityMask( PRI interruptPriority );
 *   ER             getInterruptPriorityMask( PRI* p_interruptPriority );
 *   ER             exitKernel( );
 *   bool_t         senseContext( );
 *   bool_t         senseLock( );
 *   bool_t         senseDispatch( );
 *   bool_t         senseDispatchPendingState( );
 *   bool_t         senseKernel( );
 * call port : cDriverTask  signature: sCyclic context: task
 *   ER             cDriverTask_start( );
 *   ER             cDriverTask_stop( );
 *   ER             cDriverTask_refer( T_RCYC* pk_cyclicHandlerStatus );
 * call port : cControllerTask  signature: sCyclic context: task
 *   ER             cControllerTask_start( );
 *   ER             cControllerTask_stop( );
 *   ER             cControllerTask_refer( T_RCYC* pk_cyclicHandlerStatus );
 * call port : cTouchSensor  signature: sSensor context: task
 *   void           cTouchSensor_getValue( int32_t* value );
 * call port : cLightSensor  signature: sSensor context: task
 *   void           cLightSensor_getValue( int32_t* value );
 * call port : cDisplay  signature: sDisplay context: task
 *   void           cDisplay_update( );
 *   void           cDisplay_clear( bool_t updateToo );
 *   void           cDisplay_gotoXY( int_t x, int_t y );
 *   void           cDisplay_putChar( char_t c );
 *   void           cDisplay_putString( const char_t* string );
 *   void           cDisplay_putInt( int32_t val, uint32_t places );
 *   void           cDisplay_putUnsigned( uint32_t val, uint32_t places );
 *   void           cDisplay_putHex( uint32_t val, uint32_t places );
 *   uint8_t*       cDisplay_getBuffer( );
 *   void           cDisplay_powerOff( bool_t updateToo );
 *   void           cDisplay_copyBitmap( const uint8_t* data, uint32_t width, uint32_t depth, uint32_t x, uint32_t y );
 * call port : cBalancer  signature: sBalancer context: task
 *   void           cBalancer_initialize( );
 *   void           cBalancer_control( int16_t forward, int16_t turn, int32_t gyro, int32_t gyroOffset, int32_t leftRevolution, int32_t rightRevolution, uint32_t battery, int8_t* pwm_l, int8_t* pwm_r );
 * call port : cButton  signature: sNXTButton context: task
 *   void           cButton_pollingUpdateNXTState( );
 *   bool_t         cButton_isENTERButton( );
 *   bool_t         cButton_isRUNButton( );
 *   bool_t         cButton_isSTOPButton( );
 *   bool_t         cButton_isEXITButton( );
 *   uint8_t        cButton_getButtonState( );
 *
 * #[</PREAMBLE>]# */

#include "tStarterTaskBody_tecsgen.h"

#ifndef E_OK
#define	E_OK	0		/* success */
#define	E_ID	(-18)	/* illegal ID */
#endif

/* 󂯌֐ #_TEPF_# */
/* #[<ENTRY_PORT>]# eBody
 * entry port: eBody
 * signature:  sTaskBody
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eBody_main
 * name:         eBody_main
 * global_name:  tStarterTaskBody_eBody_main
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eBody_main()
{
	int32_t touch, light, gyro;       // ZTl
	volatile bool_t touched = false;  // ^b`ZTꂽH

	/*
	 *  ʕ\
	 */
	cDisplay_clear(1);
	cDisplay_gotoXY(0, 0);
	cDisplay_putString("push touch");
	cDisplay_gotoXY(0, 1);
	cDisplay_putString("light:");
	cDisplay_gotoXY(0, 3);
	cDisplay_putString("gyro:");

	/*
	 *  ^b`ZTė܂Ń[v
	 */
	do{
		/*
		 *  ZTl擾
		 */
		cTouchSensor_getValue(&touch);
		cLightSensor_getValue(&light);
		cGyroSensor_getValue(&gyro);

		/*
		 *  ZTlʂɕ\
		 */
		cDisplay_gotoXY(0, 2);
		cDisplay_putInt(light, 0);
		cDisplay_gotoXY(0, 4);
		cDisplay_putInt(gyro, 0);
		cDisplay_update();

		/*
		 *  ^b`ZTꂽ
		 */
		if(touch > 0){
			touched = true;
		}

		/*
		 *  100mb҂
		 */
		delay(100);
	} while(!touched || (touch > 0));

	/*
	 *  ʕ\
	 */
	cDisplay_clear(1);

	/*
	 *  ^XNN
	 */
	cControllerTask_start();  // turnlvZ^XN
	cDriverTask_start();      // |s^XN
	
	exitTask();
}

/* #[<POSTAMBLE>]#
 *   艺ɔ󂯌֐܂
 * #[</POSTAMBLE>]#*/
