#ifndef _MINDSTORMS_NXT_H_
#define _MINDSTORMS_NXT_H_

/* foCXWX^̒`iat91sam7s.h̕ԁj */

#define CLOCK_FREQUENCY 48000000
#define CLOCK_RATE      48054850
#define BAUD_RATE       460800

/* USART */
#define US_USMODE_HWHSH (0x2)
#define US_SYNC         (0x1 << 8)
#define US_CLKS_CLOCK   (0x0 << 4)
#define US_OVER         (0x1 << 19)

/* TimerCounter */
#define TC_WAVE (1 << 15)
#define TC_ACPA_SET (1 << 16)
#define TC_ACPC_CLEAR (2 << 18)
#define TC_ASWTRG_SET (1 << 22)

/* PDC */
/* #define PDC_RXTEN  (1 << 0)
 * #define PDC_RXTDIS (1 << 1)
 * #define PDC_TXTEN  (1 << 8)
 * #define PDC_TXTDIS (1 << 9)
 */

/* A/D Converter */
#define ADC_TRGEN_EN (1)
#define ADC_TRGSEL_TIOA1 (1 << 1)
#define ADC_CH6 (1 << 6)
#define ADC_CH4 (1 << 4)

#endif /* _MINDSTORMS_NXT_H_ */
