/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2009 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  @(#) $Id$
 */

/*
 *		VXeO̒჌xóimindstormsNXTpj
 */

#include "tPutLogMindstormsNXT_tecsgen.h"
#include "at91sam7s.h"
#include <unistd.h>
#include "target_serial.h"

/*
 *  VXeO̒჌xo͂̂߂̕o
 */

inline void
rot_target_low_send_buf(CELLCB *p_cellcb)
{
	if(VAR_sendBufferPointer == VAR_sendBuffer1) {
		VAR_sendBufferPointer = VAR_sendBuffer2;
	} else {
		VAR_sendBufferPointer = VAR_sendBuffer1;
	}
}

/*
 *  ^[Qbgˑ̕o(჌x)
 */
void
target_fputc(CELLCB *p_cellcb, char_t c)
{

	if(__builtin_expect(VAR_sendBufferPointer == NULL, 0)) {
		VAR_sendBufferPointer = VAR_sendBuffer1; // n߂|C^
	}
	
	VAR_sendBufferPointer[VAR_sendBufferCount] = c; // Mobt@ɕ
	VAR_sendBufferCount++;                            // Mobt@̕CNg

	if(c == '\n' || VAR_sendBufferCount >= ATTR_sendBufferSize) { // s̏ꍇ or Mobt@t̏ꍇ
		/*
		 *  MoCgz̐擪ɒǉ
		 */
		VAR_sendBufferPointer[0] = (char_t)(VAR_sendBufferCount & 0xFF); // 8rbg
		VAR_sendBufferPointer[1] = (char_t)((VAR_sendBufferCount >> 8) & 0xFF); // 8rbg
		
		/*
		 *  M\(DMA]I)ɂȂ܂ő҂
		 */
		while((sil_rew_mem((void *)(ATTR_US1_BASE + TOFF_PDC_TNCR))) != 0);

		sil_wrw_mem((void *)(ATTR_US1_BASE + TOFF_PDC_TNPR), (uint_t)(VAR_sendBufferPointer)); // M̃AhX
		sil_wrw_mem((void *)(ATTR_US1_BASE + TOFF_PDC_TNCR), VAR_sendBufferCount); // MoCg
		
		rot_target_low_send_buf(p_cellcb); // Mobt@ւ
		VAR_sendBufferCount = 2U; // Mobt@̕Zbg
	}

}


/*
 *  ^[Qbgˑ̕o
 */
ER
ePutLog_putChar(CELLIDX idx, char_t c)
{
	CELLCB	*p_cellcb;

	assert(VALID_IDX(idx));
	p_cellcb = GET_CELLCB(idx);

	if((cBluetooth_getStatus() != BT_STREAM) || (cSIOPort_isOpened() == false)) { // bluetoothڑĂȂΑMłȂ
		return E_SYS;
	}

	/*
	 *  LF̑OCR𑗐M
	 */
	if(c == '\n') {
		target_fputc(p_cellcb, '\r');
	}
	
	target_fputc(p_cellcb, c);

	return E_OK;
}
