/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2010 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  @(#) $Id:
 */
/*
 *   TOPPERS Software
 *       Toyohashi Open Platform for Embedded Real-Time Systems
 *  
 *   Copyright (C) 2010 by Embedded and Real-Time Systems Laboratory
 *               Graduate School of Information Science, Nagoya Univ., JAPAN
 *  
 *   L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *   Ai{\tgEFAς̂܂ށDȉjgpEE
 *   ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *   (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *       \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *       XR[hɊ܂܂Ă邱ƁD
 *   (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *       pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *       ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *       ̖ۏ؋Kfڂ邱ƁD
 *   (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *       płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *       ƁD
 *     (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *         쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *     (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *         񍐂邱ƁD
 *   (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *       QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *       ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *       RɊÂCL쌠҂TOPPERSvWFNg
 *       Ɛӂ邱ƁD
 *  
 *   {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *   TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *   ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *   A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *   ̐ӔC𕉂ȂD
 *
 */
/*
 * ̃t@C tecsgen ɂev[gƂĎ܂
 * ̃t@CҏWĎgp邱ƂӐ}Ă܂
 * tecsgen ̍Ďsɂ㏑Ă܂߁Aʏ
 *   gen/tNXTButton_inline_template.h => src/tNXTButton_inline.h
 * ̂悤ɖO, tH_ύXĂC܂
 */
/* #[<PREAMBLE>]#
 * #[<...>]#  #[</...>]# ň͂܂ꂽRg͕ҏWȂł
 * tecsmerge ɂ}[WɎgp܂
 *
 * ANZX}N #_CAAM_#
 * threshold        int32_t          ATTR_threshold  
 * ENTER            uint8_t          ATTR_ENTER      
 * STOP             uint8_t          ATTR_STOP       
 * RUN              uint8_t          ATTR_RUN        
 * EXIT             uint8_t          ATTR_EXIT       
 * button           uint8_t          VAR_button      
 * count            int32_t          VAR_count       
 * preState         int32_t          VAR_preState    
 *
 * #[</PREAMBLE>]# */

/* 󂯌֐ #_TEPF_# */
/* #[<ENTRY_PORT>]# eButton
 * entry port: eButton
 * signature:  sNXTButton
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eButton_pollingUpdateNXTState
 * name:         eButton_pollingUpdateNXTState
 * global_name:  tNXTButton_eButton_pollingUpdateNXTState
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline void
eButton_pollingUpdateNXTState()
{
	uint8_t buttonState;
	
	buttonState = (uint8_t)cAVR_getButton() & 0x0F;

	/*
	 *  `^O
	 */
	if(VAR_preState == buttonState){
		VAR_count++;
	} else {
		VAR_count = 0;
	}

	if(VAR_count >= ATTR_threshold){
		VAR_button = buttonState;
		VAR_count = 0;
	}
	
	VAR_preState = buttonState;
	
}

/* #[<ENTRY_FUNC>]# eButton_isENTERButton
 * name:         eButton_isENTERButton
 * global_name:  tNXTButton_eButton_isENTERButton
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline bool_t
eButton_isENTERButton()
{
	return ((VAR_button & ATTR_ENTER) == ATTR_ENTER);
}

/* #[<ENTRY_FUNC>]# eButton_isRUNButton
 * name:         eButton_isRUNButton
 * global_name:  tNXTButton_eButton_isRUNButton
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline bool_t
eButton_isRUNButton()
{
	return ((VAR_button & ATTR_RUN) == ATTR_RUN);
}

/* #[<ENTRY_FUNC>]# eButton_isSTOPButton
 * name:         eButton_isSTOPButton
 * global_name:  tNXTButton_eButton_isSTOPButton
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline bool_t
eButton_isSTOPButton()
{
	return ((VAR_button & ATTR_STOP) == ATTR_STOP);
}

/* #[<ENTRY_FUNC>]# eButton_isEXITButton
 * name:         eButton_isEXITButton
 * global_name:  tNXTButton_eButton_isEXITButton
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline bool_t
eButton_isEXITButton()
{
	return ((VAR_button & ATTR_EXIT) == ATTR_EXIT);
}

/* #[<ENTRY_FUNC>]# eButton_getButtonState
 * name:         eButton_getButtonState
 * global_name:  tNXTButton_eButton_getButtonState
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline uint8_t
eButton_getButtonState()
{
	return VAR_button;
}

